// Sample_MFCView.cpp : CSample_MFCView Mounting of class
//

#include "stdafx.h"
#include "Sample_MFC.h"
#include "MainFrm.h"

#include "Sample_MFCDoc.h"
#include "Sample_MFCView.h"

#include "SetFilterDlg.h"
#include "SetSizeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#define CAP_TIMER_ID	100
#define REC_TIMER_ID	200
#define TIMER_TIME		50

const int SUB_SAMPLE[] = { 1, 2, 4, 8 };
#define ArtCamGetWidth()	(m_CArtCamSdk.Width()  / SUB_SAMPLE[m_CArtCamSdk.GetSubSample()])
#define ArtCamGetHeight()	(m_CArtCamSdk.Height() / SUB_SAMPLE[m_CArtCamSdk.GetSubSample()])
#define ArtCamGetColor()	WORD(((m_CArtCamSdk.GetColorMode() + 7) / 8) * 8)
#define ArtCamGetBpp()		(((m_CArtCamSdk.GetColorMode() + 7) / 8))
#define ArtCamGetPitch()	((ArtCamGetWidth() * ArtCamGetBpp() + 3) & ~3)
#define ArtCamGetSize()		(ArtCamGetPitch() * ArtCamGetHeight())
#define SAFE_DELETE(x)  { if(x) delete[] x; x=NULL; }


// CSample_MFCView

IMPLEMENT_DYNCREATE(CSample_MFCView, CView)

BEGIN_MESSAGE_MAP(CSample_MFCView, CView)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_MOUSEMOVE()
	ON_MESSAGE(WM_GRAPHPAINT, OnGraphPaint)
	ON_MESSAGE(WM_ERROR, OnError)
	ON_COMMAND(ID_FILE_SAVEIMAGE, OnFileSaveimage)
	ON_COMMAND(ID_FILE_REC, OnFileRec)
	ON_COMMAND(ID_FILE_EXIT, OnExit)
	ON_COMMAND(ID_SHOW_PREVIEW, OnShowPreview)
	ON_COMMAND(ID_SHOW_CALLBACK, OnShowCallback)
	ON_COMMAND(ID_SHOW_SNAPSHOT, OnShowSnapshot)
	ON_COMMAND(ID_SHOW_CAPTURE, OnShowCapture)
	ON_COMMAND(ID_SHOW_TRIGGER, OnShowTrigger)
	ON_COMMAND(ID_SHOW_STOP, OnShowStop)
	ON_COMMAND(ID_SET_FORMAT, OnSetFormat)
	ON_COMMAND(ID_SET_FILTER, OnSetFilter)
	ON_COMMAND(ID_SET_ANALOG, OnSetAnalog)
	ON_COMMAND(ID_SET_FILTER_APP, OnSetFilterApp)
	ON_COMMAND(ID_DLL_CAM, OnDllCam)
	ON_COMMAND(ID_DLL_USTC, OnDllUstc)
	ON_COMMAND(ID_DLL_CNV, OnDllCnv)
	ON_COMMAND(ID_DLL_130MI, OnDll130mi)
	ON_COMMAND(ID_DLL_200MI, OnDll200mi)
	ON_COMMAND(ID_DLL_300MI, OnDll300mi)
	ON_COMMAND(ID_DLL_150P, OnDll150p)
	ON_COMMAND(ID_DLL_320P, OnDll320p)
	ON_COMMAND(ID_DLL_200SH, OnDll200sh)
	ON_COMMAND(ID_DLL_098, OnDll098)
	ON_COMMAND(ID_DLL_036MI, OnDll036mi)
	ON_COMMAND(ID_DLL_500P, OnDll500p)
	ON_COMMAND(ID_DLL_150P2, OnDll150p2)
	ON_COMMAND(ID_DEVICE01, OnDevice01)
	ON_COMMAND(ID_DEVICE02, OnDevice02)
	ON_COMMAND(ID_DEVICE03, OnDevice03)
	ON_COMMAND(ID_DEVICE04, OnDevice04)
	ON_COMMAND(ID_DEVICE05, OnDevice05)
	ON_COMMAND(ID_DEVICE06, OnDevice06)
	ON_COMMAND(ID_DEVICE07, OnDevice07)
	ON_COMMAND(ID_DEVICE08, OnDevice08)
	ON_COMMAND(ID_SET_SIZE_APP, OnSetSizeApp)
END_MESSAGE_MAP()

// CSample_MFCView Construction/Destruction

CSample_MFCView::CSample_MFCView()
{
	theApp.m_pView = this;


	m_pImage = NULL;
	m_PreviewMode = -1;
	m_DllType = -1;
	m_DeviceCount = 0;
	m_SelectDevice = -1;

	m_SaveFlg = FALSE;
	m_StopFlg = FALSE;
}

CSample_MFCView::~CSample_MFCView()
{
}

BOOL CSample_MFCView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify "CREATESTRUCT cs" at this position and adjust Window class or style.
	//  
	cs.style |= WS_HSCROLL;
	cs.style |= WS_VSCROLL;

	return CView::PreCreateWindow(cs);
}

// CSample_MFCView Drawing

void CSample_MFCView::OnDraw(CDC* pDC)
{
	CSample_MFCDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);


	if(0 != m_PreviewMode){
		DrawImage(pDC->m_hDC);
	}
}


// CSample_MFCView Diagnosis

#ifdef _DEBUG
void CSample_MFCView::AssertValid() const
{
	CView::AssertValid();
}

void CSample_MFCView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSample_MFCDoc* CSample_MFCView::GetDocument() const // Version except debugging is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSample_MFCDoc)));
	return (CSample_MFCDoc*)m_pDocument;
}
#endif //_DEBUG


// CSample_MFCView Message handler



int CSample_MFCView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;


	// Read DLL used before first
	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath(szExePath[0], szExePath[1], szExePath[2], NULL, NULL);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);

	m_DllType = ::GetPrivateProfileInt("Sample", "DllType", -1, szFilePath);


	// Check if there is DLL
	CMenu* pMenu = GetParent()->GetMenu();
	CMenu* pDllMenu = pMenu->GetSubMenu(3);
	for(int i=0; i<DLLCOUNT; i++){
		m_MenuEnable[i] = TRUE;

		CArtCamSdk ArtCam;
		if(ArtCam.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[i]))){
			CString strd, strv;

			// Obtain version and show it
			pDllMenu->GetMenuString(i, strd, MF_BYPOSITION);
			strv.Format("Version\t%04d", LOWORD(ArtCam.GetDllVersion()));
			strd += strv;

			pDllMenu->ModifyMenu(i, MF_BYPOSITION | MF_STRING, pDllMenu->GetMenuItemID(i), strd);
		}
		// No DLL
		else {
			m_MenuEnable[i] = FALSE;
		}
	}


	// Initialize camera
	if(-1 != m_DllType)
		OnDllChange(m_DllType);

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_DESTROY
//

void CSample_MFCView::OnDestroy()
{
	CView::OnDestroy();

	TCHAR szFilePath[MAX_PATH]="";
	TCHAR szExePath[3][MAX_PATH]={"","",""};
	GetModuleFileName(::GetModuleHandle(NULL), szExePath[0], MAX_PATH);
	_splitpath(szExePath[0], szExePath[1], szExePath[2], NULL, NULL);
	wsprintf(szFilePath, "%s%sSample.ini", szExePath[1], szExePath[2]);


	TCHAR Data[32]="";
	wsprintf(Data, "%d", m_DllType);
	::WritePrivateProfileString("Sample", "DllType", Data, szFilePath);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_GRAPHPAINT
//

LRESULT CSample_MFCView::OnGraphPaint(WPARAM wParam, LPARAM lParam)
{
	// When this message come, there is latest image in m_pImage
	LPGP_INFO pGpInfo = (LPGP_INFO)wParam;
	DrawImage(NULL);


	CString Fps;
	Fps.Format("%.1f", double(pGpInfo->lFps) / 10.0);
	static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_FRAME, Fps);

	m_SaveFlg = TRUE;

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	WM_ERROR
//

LRESULT CSample_MFCView::OnError(WPARAM wParam, LPARAM lParam)
{
	if(0 <= lParam && lParam < ERRORCOUNT-1){
		static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_TEXT, ERRORLIST[lParam]);
	}
	else {
		static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_TEXT, ERRORLIST[ERRORCOUNT-1]);
	}

	return 1;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Still picture saving
//

void CSample_MFCView::OnFileSaveimage()
{
	CFileDialog FD(FALSE, NULL, "Select file", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, 
		"BITMAPFile(*.bmp)|*.bmp|JPEGFile(*.jpg)|*.jpg;*.jpeg|TIFFFile(*.tif)|*.tif;*.tiff|PNGFile(*.png)|*.png|RAWFile(*.raw)|*.raw||", this);

	if(IDOK == FD.DoModal()){
		OPENFILENAME ofn = FD.GetOFN();

		// Set extension yourself
		TCHAR szTemp[4][MAX_PATH]={"","","",""};
		_splitpath(ofn.lpstrFile, szTemp[0], szTemp[1], szTemp[2], szTemp[3]);

		CString str;
		switch(ofn.nFilterIndex){
		case 1:	str.Format("%s%s%s.bmp", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_BITMAP);		break;
		case 2:	str.Format("%s%s%s.jpg", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_JPEG_HIGH);	break;
		case 3:	str.Format("%s%s%s.tif", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_TIFF);			break;
		case 4:	str.Format("%s%s%s.png", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_PNG);			break;
		case 5:	str.Format("%s%s%s.raw", szTemp[0], szTemp[1], szTemp[2]);	m_CArtCamSdk.SaveImage(str, FILETYPE_RAW);			break;
		break;
		}
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Animated picture saving(Only for Directshow version)
//

void CSample_MFCView::OnFileRec()
{
	CFileDialog FD(FALSE, "avi", "Select file", OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, "AVIFile(*.avi)|*.avi||", this);

	if(IDOK == FD.DoModal()){
		m_RecName = FD.GetPathName();

		// Pause
		m_CArtCamSdk.Close();

		// Display on different window while recording
		// When "hWnd" is NULL, window is created from SDK side and therefore the size is not important.
		m_CArtCamSdk.SetPreviewWindow(NULL, 0, 0, 0, 0);

		// 5 seconds recording
		m_CArtCamSdk.Record(m_RecName, 5000, 1);


		// Timing for record ending is not sent from SDK and therefore it needs to be stopped by software.
		// Just in case, run the timer for 1 sencond longer.
		SetTimer(REC_TIMER_ID, 6000, NULL);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	End
//

void CSample_MFCView::OnExit()
{
	PostMessage(WM_CLOSE);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Draw image
//

struct BITMAPINFO2 {
	BITMAPINFOHEADER   bmiHeader;
	RGBQUAD            bmiColors[256];
};

LRESULT CSample_MFCView::DrawImage(HDC hDC)
{
	if(NULL == m_pImage){
		return 0;
	}

	BOOL Flg = FALSE;
	if(NULL == hDC){
		hDC = ::GetDC(m_hWnd);
		Flg = TRUE;
	}

	CPoint Pos;
	Pos.x = GetScrollPos(SB_HORZ);
	Pos.y = GetScrollPos(SB_VERT);


	if(hDC){
		LONG Width = ArtCamGetWidth();
		LONG Height = ArtCamGetHeight();
		LONG Bpp = ArtCamGetBpp();

		BITMAPINFO2 bm;
		bm.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
		bm.bmiHeader.biPlanes = 1;
		bm.bmiHeader.biCompression = BI_RGB;
		bm.bmiHeader.biSizeImage = 0;
		bm.bmiHeader.biXPelsPerMeter = 0;
		bm.bmiHeader.biYPelsPerMeter = 0;
		bm.bmiHeader.biClrUsed = 0;
		bm.bmiHeader.biClrImportant = 0;

		bm.bmiHeader.biWidth = Width;
		bm.bmiHeader.biHeight = Height;


		// Monochrome 8 bit picture transfer 
		if(1 == Bpp){
			bm.bmiHeader.biBitCount = 8;

			for(int i=0; i<256; i++){
				bm.bmiColors[i].rgbRed = i;
				bm.bmiColors[i].rgbGreen = i;
				bm.bmiColors[i].rgbBlue = i;
				bm.bmiColors[i].rgbReserved = 0;
			}
			::SetDIBColorTable(hDC, 0, 256, bm.bmiColors);

			SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
								0, 0, 0, bm.bmiHeader.biHeight, m_pImage, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
		}

		// Monochromatic 10 bit/16 bit picture transfer
		else if(2 == Bpp){
			bm.bmiHeader.biBitCount = 8;

			for(int i=0; i<256; i++){
				bm.bmiColors[i].rgbRed = i;
				bm.bmiColors[i].rgbGreen = i;
				bm.bmiColors[i].rgbBlue = i;
				bm.bmiColors[i].rgbReserved = 0;
			}
			::SetDIBColorTable(hDC, 0, 256, bm.bmiColors);

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest =        pTemp     + (y * bm.bmiHeader.biWidth);
					LPWORD pSrc  = LPWORD(m_pImage) + (y * bm.bmiHeader.biWidth);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = BYTE(pSrc[0] >> 2);

						pDest++;
						pSrc ++;
					}
				}


				SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
									0, 0, 0, bm.bmiHeader.biHeight, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}

		// Color 24 bit transfer
		else if(3 == Bpp){
			bm.bmiHeader.biBitCount = 24;
			SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
								0, 0, 0, bm.bmiHeader.biHeight, m_pImage, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
		}

		// Color 32 bit transfer
		else if(4 == Bpp){
			bm.bmiHeader.biBitCount = 24;

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight * 3];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest = pTemp    + (y * bm.bmiHeader.biWidth * 3);
					LPBYTE pSrc  = m_pImage + (y * bm.bmiHeader.biWidth * 4);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = pSrc[0];
						pDest[1] = pSrc[1];
						pDest[2] = pSrc[2];

						pDest+=3;
						pSrc +=4;
					}
				}


				SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
									0, 0, 0, bm.bmiHeader.biHeight, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}

		// Color 48, 64 bit transfer
		else if(6 == Bpp || 8 == Bpp){
			bm.bmiHeader.biBitCount = 24;
			Bpp /= 2;

			LPBYTE pTemp = new BYTE[bm.bmiHeader.biWidth * bm.bmiHeader.biHeight * 3];
			if(pTemp){
				for(int y=0; y<bm.bmiHeader.biHeight; y++){

					LPBYTE pDest =        pTemp     + (y * bm.bmiHeader.biWidth * 3);
					LPWORD pSrc  = LPWORD(m_pImage) + (y * bm.bmiHeader.biWidth * Bpp);

					for(int x=0; x<bm.bmiHeader.biWidth; x++){
						pDest[0] = BYTE(pSrc[0] >> 2);
						pDest[1] = BYTE(pSrc[1] >> 2);
						pDest[2] = BYTE(pSrc[2] >> 2);

						pDest+=3;
						pSrc +=Bpp;
					}
				}


				SetDIBitsToDevice(hDC, -Pos.x, -Pos.y, bm.bmiHeader.biWidth, bm.bmiHeader.biHeight,
									0, 0, 0, bm.bmiHeader.biHeight, pTemp, (BITMAPINFO*)&bm, DIB_RGB_COLORS);
				delete[] pTemp;
			}
		}


		if(Flg){
			::ReleaseDC(m_hWnd, hDC);
		}

		return 1;
	}

	return 0;
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Draw line with SDK
//

void CSample_MFCView::OnShowPreview()
{
	// Not selected DLL
	if(-1 == m_DllType){
		AfxMessageBox("Select DLL for the camera connected");
		return;
	}

	// Delete timer
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// Release device
	m_CArtCamSdk.Close();


	// Release area for image
	SAFE_DELETE(m_pImage);


	// Set window to be displayed
	// When setting NULL to hWnd,it is possible to create new window and show it.
	CRect rc;
	GetClientRect(&rc);
	m_CArtCamSdk.SetPreviewWindow(m_hWnd, 0, 0, rc.right, rc.bottom);


	// Display image
	m_CArtCamSdk.Preview();


	// Check menu
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_CHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = 0;
	m_SaveFlg = TRUE;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");

	ChangeScrollbar();
	Invalidate();
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Obtain image pointer and draw with application
//

void CSample_MFCView::OnShowCallback()
{
	// Not selected DLL
	if(-1 == m_DllType){
		AfxMessageBox("Select DLL for the camera connected");
		return;
	}

	// Delete timer
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// Release device
	m_CArtCamSdk.Close();


	// Release area for image
	SAFE_DELETE(m_pImage);


	// If drawing by yourself, set all window size to 0.
	// An automatic display can be performed, if window size is set up even when using CallBackPreview
	m_CArtCamSdk.SetPreviewWindow(m_hWnd, 0, 0, 0, 0);


	// Secure the space for taking in
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.CallBackPreview(m_hWnd, m_pImage, ArtCamGetSize(), 0);


	// Check menu
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_CHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = 1;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");

	ChangeScrollbar();
	Invalidate();
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Display one frame
//

void CSample_MFCView::OnShowSnapshot()
{
	// Not selected DLL
	if(-1 == m_DllType){
		AfxMessageBox("Select DLL for the camera connected");
		return;
	}

	// Delete timer
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// Release device
	m_CArtCamSdk.Close();


	// Release area for image
	SAFE_DELETE(m_pImage);

	// Secure the space for taking in
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.SnapShot(m_pImage, ArtCamGetSize(), 0);
	m_SaveFlg = TRUE;


	// Draw image
	DrawImage(NULL);

	// Check menu
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = -1;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Draw line with SDK
//

void CSample_MFCView::OnShowCapture()
{
	// Not selected DLL
	if(-1 == m_DllType){
		AfxMessageBox("Select DLL for the camera connected");
		return;
	}


	// Release device
	m_CArtCamSdk.Close();

	// Release area for image
	SAFE_DELETE(m_pImage);

	// Secure the space for taking in
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.Capture();


	// Check menu
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_CHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_UNCHECKED);

	m_PreviewMode = 3;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");

	ChangeScrollbar();
	Invalidate();

	SetTimer(CAP_TIMER_ID, TIMER_TIME, NULL);
}


void CSample_MFCView::OnTimer(UINT nIDEvent)
{
	if(3 == m_PreviewMode && CAP_TIMER_ID == nIDEvent){
		KillTimer(CAP_TIMER_ID);

		m_CArtCamSdk.SnapShot(m_pImage, ArtCamGetSize(), 0);
		m_SaveFlg = TRUE;

		// Draw image
		DrawImage(NULL);

		SetTimer(CAP_TIMER_ID, TIMER_TIME, NULL);
	}

	// Finish recording
	if(REC_TIMER_ID == nIDEvent){
		m_CArtCamSdk.Close();
		KillTimer(REC_TIMER_ID);

		if(IDYES == MessageBox("Recording completePlay /n file?", "Complete", MB_YESNO | MB_ICONQUESTION)){
			::ShellExecute(NULL, NULL, m_RecName, NULL, NULL, SW_SHOWNORMAL);
		}
	}

	CView::OnTimer(nIDEvent);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Trigger mode
//

void CSample_MFCView::OnShowTrigger()
{
	// Not selected DLL
	if(-1 == m_DllType){
		AfxMessageBox("Select DLL for the camera connected");
		return;
	}

	// Delete timer
	if(3 == m_PreviewMode){
		KillTimer(CAP_TIMER_ID);
	}

	// Release device
	m_CArtCamSdk.Close();


	// Release area for image
	SAFE_DELETE(m_pImage);


	// If drawing by yourself, set all window size to 0.
	// An automatic display can be performed, if window size is set up even when using CallBackPreview
	m_CArtCamSdk.SetPreviewWindow(m_hWnd, 0, 0, 0, 0);


	// Secure the space for taking in
	m_pImage = new BYTE[ArtCamGetSize()];

	m_CArtCamSdk.Trigger(m_hWnd, m_pImage, ArtCamGetSize(), 0);


	// Check menu
	CMenu* pShowMenu = GetParent()->GetMenu()->GetSubMenu(1);
	pShowMenu->CheckMenuItem(0, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(1, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(3, MF_BYPOSITION | MF_UNCHECKED);
	pShowMenu->CheckMenuItem(4, MF_BYPOSITION | MF_CHECKED);

	m_PreviewMode = 4;
	m_StopFlg = FALSE;
	GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");

	ChangeScrollbar();
	Invalidate();
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Display pause/resume
//

void CSample_MFCView::OnShowStop()
{
	// Stop only for animated picture
	if(0 == m_PreviewMode || 1 == m_PreviewMode){
		if(m_StopFlg){
			m_CArtCamSdk.StartPreview();
			m_StopFlg = FALSE;

			GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");
		}
		else {
			m_CArtCamSdk.StopPreview();
			m_StopFlg = TRUE;

			GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Resume");
		}
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Change DLL
//

BOOL CSample_MFCView::OnDllChange(LONG DllType)
{
	// Release all devices before switching DLL
	// To display multiple images simulteously, you need to define CArtCamSdk plurally
	// When defined plurally, you do not need to relase to switch cameras
	m_CArtCamSdk.Release();
	m_CArtCamSdk.FreeLibrary();


	if(!m_CArtCamSdk.LoadLibrary(const_cast<LPTSTR>(DLLNAMELIST[DllType]))){
		CString Error;
		Error.Format("%s is not found.\nDLL may have been relocated after executing", DLLNAMELIST[DllType]);
		AfxMessageBox(Error);
		return FALSE;
	}

	// Initialize is to be called first
	// By setting Window Handle here, WMLERROR can be obtained
	if(!m_CArtCamSdk.Initialize(m_hWnd)){
		AfxMessageBox("Failed to initialize SDK");
		return FALSE;
	}

	CMenu* pMenu = GetParent()->GetMenu();

	// Check menu
	CMenu* pDllMenu = pMenu->GetSubMenu(3);

	for(int i=0; i<DLLCOUNT; i++){
		pDllMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
	}
	pDllMenu->CheckMenuItem(DllType, MF_BYPOSITION | MF_CHECKED);


	// Device modification menu
	CMenu* pDeviceMenu = pMenu->GetSubMenu(4);

	TCHAR szName[10][256];
	TCHAR szDef[10][256] = { "0", "1", "2", "3", "4", "5", "6", "7", "8", "9" };
	m_DeviceCount = m_CArtCamSdk.EnumDevice(szName);

	for(int i=0; i<m_DeviceCount; i++){
		pDeviceMenu->ModifyMenu(i, MF_BYPOSITION | MF_STRING, ID_DEVICE01 + i, szName[i]);
	}
	for(; i<10; i++){
		pDeviceMenu->ModifyMenu(i, MF_BYPOSITION | MF_STRING, ID_DEVICE01 + i, szDef[i]);
	}

	m_SaveFlg = FALSE;

	// Device setting
	return OnDeviceChange(0);
}


void CSample_MFCView::OnDllCam()	{ m_DllType =  0; OnDllChange( 0); }
void CSample_MFCView::OnDllUstc()	{ m_DllType =  2; OnDllChange( 2); }
void CSample_MFCView::OnDllCnv()	{ m_DllType =  3; OnDllChange( 3); }
void CSample_MFCView::OnDll130mi()	{ m_DllType =  5; OnDllChange( 5); }
void CSample_MFCView::OnDll200mi()	{ m_DllType =  6; OnDllChange( 6); }
void CSample_MFCView::OnDll300mi()	{ m_DllType =  7; OnDllChange( 7); }
void CSample_MFCView::OnDll150p()	{ m_DllType =  8; OnDllChange( 8); }
void CSample_MFCView::OnDll320p()	{ m_DllType =  9; OnDllChange( 9); }
void CSample_MFCView::OnDll200sh()	{ m_DllType = 10; OnDllChange(10); }
void CSample_MFCView::OnDll098()	{ m_DllType = 11; OnDllChange(11); }
void CSample_MFCView::OnDll036mi()	{ m_DllType = 12; OnDllChange(12); }
void CSample_MFCView::OnDll500p()	{ m_DllType = 13; OnDllChange(13); }
void CSample_MFCView::OnDll150p2()	{ m_DllType = 14; OnDllChange(14); }


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Change device
//

BOOL CSample_MFCView::OnDeviceChange(LONG Number)
{
	// Not selected DLL
	if(-1 == m_DllType){
		AfxMessageBox("Select DLL for the camera connected");
		return FALSE;
	}


	// Release the operative device before switching device
	m_CArtCamSdk.Close();


	// To confirm whether the device is connected, use "GetDeviceName"
	// It can be found out easily with "GetDeviceName".
	// When area for obtain name is not secured, it results in error. Prepare alignment length of at least 32.
	TCHAR szName[256]="";
	if(!m_CArtCamSdk.GetDeviceName(Number, szName, 256)){
		m_PreviewMode = -1;
		m_SelectDevice = -1;
		m_StopFlg = FALSE;
		GetParent()->GetMenu()->GetSubMenu(1)->ModifyMenu(6, MF_BYPOSITION | MF_STRING, ID_SHOW_STOP, "Pause");
		return FALSE;
	}


	// A device will be changed, if a camera is displayed after changing the number of a device now
	// Notes: A device is not changed in this function simple substance
	//   After calling this function, a device is changed by initializing a device
	m_SelectDevice = Number;
	m_CArtCamSdk.SetDeviceNumber(Number);


	CMenu* pMenu = GetParent()->GetMenu();
	CMenu* pDeviceMenu = pMenu->GetSubMenu(4);

	for(int i=0; i<8; i++){
		pDeviceMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
	}
	pDeviceMenu->CheckMenuItem(Number, MF_BYPOSITION | MF_CHECKED);


	switch(m_PreviewMode){
	case 0: OnShowPreview();  return TRUE;
	case 1: OnShowCallback(); return TRUE;
	case 3: OnShowCapture(); return TRUE;
	case 4: OnShowTrigger(); return TRUE;
	}

	return TRUE;
}

void CSample_MFCView::OnDevice01()	{ OnDeviceChange(0); }
void CSample_MFCView::OnDevice02()	{ OnDeviceChange(1); }
void CSample_MFCView::OnDevice03()	{ OnDeviceChange(2); }
void CSample_MFCView::OnDevice04()	{ OnDeviceChange(3); }
void CSample_MFCView::OnDevice05()	{ OnDeviceChange(4); }
void CSample_MFCView::OnDevice06()	{ OnDeviceChange(5); }
void CSample_MFCView::OnDevice07()	{ OnDeviceChange(6); }
void CSample_MFCView::OnDevice08()	{ OnDeviceChange(7); }


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Setting window
//

void CSample_MFCView::OnSetFormat()
{
	// Please use this function after stop image
	// In case of calling before stop
	// Stop with SDK and restart to display after close dialog

	// In this case it reflects image size of SDK when change size
	// Also there is possibility not to obtain image correctly if you don't refresh data saved in application

	m_CArtCamSdk.Close();
	m_CArtCamSdk.SetCameraDlg(m_hWnd);

	switch(m_PreviewMode){
	case 0: OnShowPreview();  return ;
	case 1: OnShowCallback(); return ;
	case 3: OnShowCapture(); return ;
	case 4: OnShowTrigger(); return ;
	}
}

void CSample_MFCView::OnSetFilter()
{
	// Please call this function
	// on condition that animated picture is displayed
	// It is possible to set while stop, but it is not recommended

	m_CArtCamSdk.SetImageDlg(m_hWnd);
}

void CSample_MFCView::OnSetAnalog()
{
	// Please call this function
	// on condition that animated picture is displayed
	// It is possible to set while stop, but it is not recommended

	m_CArtCamSdk.SetAnalogDlg(m_hWnd);
}

void CSample_MFCView::OnSetFilterApp()
{
	// A large quantity of functions  for setting are used inside
	// Please use on condition camera is connected

	// It is possible to set the number controlled inside of SDK
	// even if camera is not connected
	// but it is not recommended

	CSetFilterDlg SFD;
	SFD.m_pCArtCamSdk = &m_CArtCamSdk;
	SFD.m_Preview = m_PreviewMode;
	SFD.DoModal();
}

void CSample_MFCView::OnSetSizeApp()
{
	m_CArtCamSdk.Close();

	CSetSizeDlg SSD;
	SSD.m_pCArtCamSdk = &m_CArtCamSdk;
	SSD.DoModal();

	switch(m_PreviewMode){
	case 0: OnShowPreview();  return ;
	case 1: OnShowCallback(); return ;
	case 3: OnShowCapture(); return ;
	case 4: OnShowTrigger(); return ;
	}
}



//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Menu
//

void CSample_MFCView::InitMenuPopup(CMenu* pPopupMenu)
{
	CMenu* pMenu = GetParent()->GetMenu();

	// Something related to file archive
	if(pPopupMenu == pMenu->GetSubMenu(0)){
		// Check if saving is available (if an image has been captured at least once, it is possible).
		if(m_SaveFlg){
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
		} else {
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_GRAYED);
		}

		// Check is the camera is Directshow compatible
		// Only Directshow camera has recording function
		if(0 == m_DllType){
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);
		} else {
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_GRAYED);
		}
	}

	// Related to drawing line
	if(pPopupMenu == pMenu->GetSubMenu(1)){
		// Disable playback if device is not connected
		if(-1 == m_SelectDevice){
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(3, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->EnableMenuItem(4, MF_BYPOSITION | MF_GRAYED);
		} else {
			pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->EnableMenuItem(3, MF_BYPOSITION | MF_ENABLED);

			// Remark: Trigger mode is not available in every model.
			switch(m_DllType){
			case 0:		// DS
			case 2:		// UST
			case 3:		// CNV
			case 10:	// 200SH
			case 11:	// 098
			case 13:	// 500P
				pPopupMenu->EnableMenuItem(4, MF_BYPOSITION | MF_GRAYED);
			break;

			default:
				pPopupMenu->EnableMenuItem(4, MF_BYPOSITION | MF_ENABLED);
			break;
			}
		}
	}

	// Switch to ON or OFF of setting window
	if(pPopupMenu == pMenu->GetSubMenu(2)){

		// Directshow is not available in every model.
		// Note that "SetAnalogDlg" is not available in many models.
		pPopupMenu->EnableMenuItem(0, MF_BYPOSITION | MF_ENABLED);
		pPopupMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);

		switch(m_DllType){
//		case 0:		// DS
		case 2:		// UST
		case 3:		// CNV
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_GRAYED);
		break;

		default:
			pPopupMenu->EnableMenuItem(2, MF_BYPOSITION | MF_ENABLED);
		break;
		}
	}

	// Active DLL
	if(pPopupMenu == pMenu->GetSubMenu(3)){
		for(int i=0; i<DLLCOUNT; i++){
			if(!m_MenuEnable[i]){
				pPopupMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
			}
		}
	}

	// Active device
	if(pPopupMenu == pMenu->GetSubMenu(4)){
		for(int i=0; i<m_DeviceCount; i++){
			pPopupMenu->EnableMenuItem(i, MF_BYPOSITION | MF_ENABLED);
			pPopupMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
		}
		for(; i<10; i++){
			pPopupMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
			pPopupMenu->CheckMenuItem(i, MF_BYPOSITION | MF_UNCHECKED);
		}

		pPopupMenu->CheckMenuItem(m_SelectDevice, MF_BYPOSITION | MF_CHECKED);
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::ChangeScrollbar(void)
{
	if(0 == m_PreviewMode){
		SetScrollPos(SB_HORZ, 0);
		SetScrollPos(SB_VERT, 0);
		ShowScrollBar(SB_HORZ, FALSE);
		ShowScrollBar(SB_VERT, FALSE);
		return;
	}


	CRect rc;
	GetClientRect(&rc);

	LONG lWidth  = ArtCamGetWidth();
	LONG lHeight = ArtCamGetHeight();

	LONG PosX = GetScrollPos(SB_HORZ);
	LONG PosY = GetScrollPos(SB_VERT);


	SCROLLINFO sc;
	sc.fMask	= SIF_RANGE | SIF_POS | SIF_PAGE;

	LONG OffsetH = 16;
	LONG OffsetV = 16;


	if(rc.right + OffsetH >= lWidth){
		ShowScrollBar(SB_HORZ, FALSE);
	} else {
		sc.nMin		= 0;
		sc.nMax		= lWidth;
		sc.nPage	= rc.right;
		sc.nPos		= PosX;
		SetScrollInfo(SB_HORZ, &sc);
	}

	if(rc.bottom + OffsetV >= lHeight){
		ShowScrollBar(SB_VERT, FALSE);
	} else {
		sc.nMin		= 0;
		sc.nMax		= lHeight;
		sc.nPage	= rc.bottom;
		sc.nPos		= PosY;
		SetScrollInfo(SB_VERT, &sc);
	}

	if(lWidth  - rc.right  < PosX)	SetScrollPos(SB_HORZ, lWidth  - rc.right);
	if(lHeight - rc.bottom < PosY)	SetScrollPos(SB_VERT, lHeight - rc.bottom);
	if(0.0 > PosX)					SetScrollPos(SB_HORZ, 0);
	if(0.0 > PosY)					SetScrollPos(SB_VERT, 0);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Change size
//

void CSample_MFCView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);

	if(0 == m_PreviewMode){
		CWnd* pChild = GetWindow(GW_CHILD);

		CRect rc;
		GetClientRect(&rc);


		// To avoiding changing aspect ratio, remove comment

		// Calculation results in decimal figure. So apply floating-point calculations.
		double winW = rc.right;
		double winH = rc.bottom;
		double capW = ArtCamGetWidth();
		double capH = ArtCamGetHeight();

		if( (winW * capH) > (winH * capW) ){
			winW = winH * capW / capH;
			rc.right = LONG(winW);
		}
		else if( (winW * capH) < (winH * capW) ){
			winH = winW * capH / capW;
			rc.bottom = LONG(winH);
		}

		pChild->SetWindowPos(&CWnd::wndTop, 0, 0, rc.right, rc.bottom, SWP_NOMOVE | SWP_NOZORDER | SWP_SHOWWINDOW);
	}

	if(1 == m_PreviewMode || 3 == m_PreviewMode || 4 == m_PreviewMode){
		ChangeScrollbar();
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO sc;
	GetScrollInfo(SB_HORZ, &sc);

	switch(nSBCode){
	case SB_LEFT:			SetScrollPos(SB_HORZ, 0);									break;
	case SB_ENDSCROLL:																	break;
	case SB_LINELEFT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) - sc.nPage/4);	break;
	case SB_LINERIGHT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) + sc.nPage/4);	break;
	case SB_PAGELEFT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) - sc.nPage);	break;
	case SB_PAGERIGHT:		SetScrollPos(SB_HORZ, GetScrollPos(SB_HORZ) + sc.nPage);	break;
	case SB_RIGHT:			SetScrollPos(SB_HORZ, GetScrollLimit(SB_HORZ));				break;
	case SB_THUMBPOSITION:	nPos &= 0x0000FFFF;	SetScrollPos(SB_HORZ, nPos);			break;
	case SB_THUMBTRACK:		nPos &= 0x0000FFFF;	SetScrollPos(SB_HORZ, nPos);			break;
	}

	DrawImage(NULL);

	CView::OnHScroll(nSBCode, nPos, pScrollBar);
}


//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	SCROLLINFO sc;
	GetScrollInfo(SB_VERT, &sc);

	switch(nSBCode){
	case SB_LEFT:			SetScrollPos(SB_VERT, 0);									break;
	case SB_ENDSCROLL:																	break;
	case SB_LINELEFT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) - sc.nPage/4);	break;
	case SB_LINERIGHT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) + sc.nPage/4);	break;
	case SB_PAGELEFT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) - sc.nPage);	break;
	case SB_PAGERIGHT:		SetScrollPos(SB_VERT, GetScrollPos(SB_VERT) + sc.nPage);	break;
	case SB_RIGHT:			SetScrollPos(SB_VERT, GetScrollLimit(SB_VERT));				break;
	case SB_THUMBPOSITION:	nPos &= 0x0000FFFF;	SetScrollPos(SB_VERT, nPos);			break;
	case SB_THUMBTRACK:		nPos &= 0x0000FFFF;	SetScrollPos(SB_VERT, nPos);			break;
	}

	DrawImage(NULL);

	CView::OnVScroll(nSBCode, nPos, pScrollBar);
}

//////////////////////////////////////////////////////////////////////////////////////////////
//
//	
//

void CSample_MFCView::OnMouseMove(UINT nFlags, CPoint point)
{
	CString strx, stry;
	strx.Format("%d", point.x + GetScrollPos(SB_HORZ));
	stry.Format("%d", point.y + GetScrollPos(SB_VERT));

	static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_X, strx);
	static_cast<CMainFrame*>(theApp.m_pMainWnd)->SetStatusText(STATUS_Y, stry);

	CView::OnMouseMove(nFlags, point);
}



