unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Menus, ArtCam, AppEvnts, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    PopupFile: TMenuItem;
    FileSave: TMenuItem;
    FileExit: TMenuItem;
    PopupShow: TMenuItem;
    ShowPreview: TMenuItem;
    ShowCallBack: TMenuItem;
    ShowSnapShot: TMenuItem;
    ShowCapture: TMenuItem;
    ShowTrigger: TMenuItem;
    PopupSet: TMenuItem;
    SetCamera: TMenuItem;
    SetFilter: TMenuItem;
    SetAnalog: TMenuItem;
    PopupDll: TMenuItem;
    DIRECTSHOW: TMenuItem;
    ARTUST: TMenuItem;
    ARTCNV: TMenuItem;
    ARTCAM130MI: TMenuItem;
    ARTCAM200MI: TMenuItem;
    ARTCAM300MI: TMenuItem;
    ARTCAM150P: TMenuItem;
    ARTCAM320P: TMenuItem;
    ARTCAM200SH: TMenuItem;
    ARTCAM098: TMenuItem;
    ARTCAM036MI: TMenuItem;
    ARTCAM500P: TMenuItem;
    ARTCAM150P2: TMenuItem;
    ARTCAM500MI: TMenuItem;
    ARTCAMT111: TMenuItem;
    ARTCAMT112: TMenuItem;
    ARTCAM150P3: TMenuItem;
    ARTCAM130MIV: TMenuItem;
    ARTCAM150P3V: TMenuItem;
    ARTCAM267KY: TMenuItem;
    ARTCAM274KY: TMenuItem;
    PopupDllSata: TMenuItem;
    ARTCAMSLVDS: TMenuItem;
    ARTCAMS300MI: TMenuItem;
    ARTCAMS500MI: TMenuItem;
    ARTCAMSMV413: TMenuItem;
    ARTCAMS800MI: TMenuItem;
    ARTCAMS036MI: TMenuItem;
    ARTCAMS150P: TMenuItem;
    PopupDevice: TMenuItem;
    Device0: TMenuItem;
    Device1: TMenuItem;
    Device2: TMenuItem;
    Device3: TMenuItem;
    Device4: TMenuItem;
    Device5: TMenuItem;
    Device6: TMenuItem;
    Device7: TMenuItem;
    Timer1: TTimer;
    N1: TMenuItem;
    N2: TMenuItem;

    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure ExitClick(Sender: TObject);
    procedure PreviewClick(Sender: TObject);
    procedure CallBackClick(Sender: TObject);
    procedure SnapShotClick(Sender: TObject);
    procedure CaptureClick(Sender: TObject);
    procedure TriggerClick(Sender: TObject);
    procedure SetCameraClick(Sender: TObject);
    procedure SetFilterClick(Sender: TObject);
    procedure SetAnalogClick(Sender: TObject);
    procedure Device0Click(Sender: TObject);
    procedure Device1Click(Sender: TObject);
    procedure Device2Click(Sender: TObject);
    procedure Device3Click(Sender: TObject);
    procedure Device4Click(Sender: TObject);
    procedure Device5Click(Sender: TObject);
    procedure Device6Click(Sender: TObject);
    procedure Device7Click(Sender: TObject);
    procedure DSCameraClick(Sender: TObject);
    procedure ARTUSTClick(Sender: TObject);
    procedure ARTCNVClick(Sender: TObject);
    procedure ARTCAM130MIClick(Sender: TObject);
    procedure ARTCAM200MIClick(Sender: TObject);
    procedure ARTCAM300MIClick(Sender: TObject);
    procedure ARTCAM150PClick(Sender: TObject);
    procedure ARTCAM320PClick(Sender: TObject);
    procedure ARTCAM200SHClick(Sender: TObject);
    procedure ARTCAM098Click(Sender: TObject);
    procedure ARTCAM036MIClick(Sender: TObject);
    procedure ARTCAM500PClick(Sender: TObject);
    procedure ARTCAM150P2Click(Sender: TObject);
    procedure ARTCAM500MIClick(Sender: TObject);
    procedure ARTCAMT111Click(Sender: TObject);
    procedure ARTCAMT112Click(Sender: TObject);
    procedure ARTCAM150P3Click(Sender: TObject);
    procedure ARTCAM130MIVClick(Sender: TObject);
    procedure ARTCAM150P3VClick(Sender: TObject);
    procedure ARTCAM267KYClick(Sender: TObject);
    procedure ARTCAM274KYClick(Sender: TObject);
    procedure ARTCAMSLVDSClick(Sender: TObject);
    procedure ARTCAMS300MIClick(Sender: TObject);
    procedure ARTCAMS500MIClick(Sender: TObject);
    procedure ARTCAMSMV413Click(Sender: TObject);
    procedure ARTCAMS800MIClick(Sender: TObject);
    procedure ARTCAMS036MIClick(Sender: TObject);
    procedure ARTCAMS150PClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private 錾 }
  public
    procedure CreateBitmap;
    procedure DrawImage;
    procedure DeviceChange(Sender: TObject; Number: Integer);
    procedure DllChange(Sender: TObject; Number: Integer; CameraType: Integer);
    function ArtCamGetWidth: Integer;
    function ArtCamGetHeight: Integer;
    function ArtCamGetColor: Integer;
    function ArtCamGetBpp: Integer;
    function ArtCamGetSize: Integer;
  end;

  function MsgProc(code: integer; wparam: WPARAM; lparam: LPARAM): LRESULT; stdcall;

var
  Form1: TForm1;
  BmpDraw: TBitmap;
  BmpCapture: TBitmap;
  ArtCam1: TArtCam;
  Hook: HHOOK;
  PreviewMode: Integer;

const
  SUB_SAMPLE: array[0..3] of Integer = (1, 2, 4, 8);

  DllNameList: array[0..24, 0..63] of AnsiChar = (
      'ArtCamSdk.dll',
      '',
      'ArtCamSdk_USTC.dll',
      'ArtCnvSdk.dll',
      '',
      'ArtCamSdk_130MI.dll',
      'ArtCamSdk_200MI.dll',
      'ArtCamSdk_300MI.dll',
      'ArtCamSdk_150P.dll',
      'ArtCamSdk_320P.dll',
      'ArtCamSdk_200SH.dll',
      'ArtCamSdk_098.dll',
      'ArtCamSdk_036MI.dll',
      'ArtCamSdk_500P.dll',
      'ArtCamSdk_150P2.dll',
      'ArtCamSdk_500MI.dll',
      'ArtCamSdk_T111.dll',
      'ArtCamSdk_T112.dll',
      'ArtCamSdk_150P3.dll',
      'ArtCamSdk_130MIV.dll',
      'ArtCamSdk_150P3V.dll',
      'ArtCamSdk_267KY.dll',
      'ArtCamSdk_274KY.dll',
      '',
      'ArtCamSdk_Sata.dll'
    );


implementation

{$R *.dfm}


//////////////////////////////////////////////////
// Lv`bZ[W󂯎
//////////////////////////////////////////////////
function MsgProc(code: integer; wparam: WPARAM; lparam: LPARAM): LRESULT; stdcall;
var
  Msg: PMsg;
begin
  if code < 0 then begin
    result := CallNextHookEx(Hook, code, wparam, lparam);
    exit;
  end;

  if code = HC_ACTION then begin
    Msg := PMsg(lparam);

    case Msg.message of
      // `R[h@ŐV̉f荞܂ꂽۂɂrcj瑗܂
      UINT(WM_GRAPHPAINT): begin
        Form1.DrawImage;
      end;

      // G[R[h
      UINT(WM_ERROR): begin
        case ARTCAMSDK_ERROR(Msg.lParam) of
          ARTCAMSDK_NOERROR:        Form1.Caption := 'Sample';
          ARTCAMSDK_NOT_INITIALIZE: Form1.Caption := 'Sample Ă܂';
          ARTCAMSDK_DISABLEDDEVICE: Form1.Caption := 'Sample ps\ȃfoCXɃANZX悤Ƃ܂';
          ARTCAMSDK_CREATETHREAD:   Form1.Caption := 'Sample 摜荞ݗpXbh쐬Ɏs';
          ARTCAMSDK_CREATEWINDOW:   Form1.Caption := 'Sample EBhE쐬Ɏs';
          ARTCAMSDK_OUTOFMEMORY:    Form1.Caption := 'Sample C[W]ɏ\ȃmۂĂȂ@́@̊mۂɎs';
          ARTCAMSDK_CAMERASET:      Form1.Caption := 'Sample JifoCXj̐ݒŃG[';
          ARTCAMSDK_CAPTURE:        Form1.Caption := 'Sample f荞݂Ŏs';
          ARTCAMSDK_PARAM:          Form1.Caption := 'Sample ԈĂ܂';
          ARTCAMSDK_DIRECTSHOW:     Form1.Caption := 'Sample DirectShow G[';
          ARTCAMSDK_UNSUPPORTED:    Form1.Caption := 'Sample ̋@\̓T|[gĂ܂';
          ARTCAMSDK_UNKNOWN:        Form1.Caption := 'Sample s̃G[';
          ARTCAMSDK_CAPTURELOST:    Form1.Caption := 'Sample foCX܂';
          ARTCAMSDK_FILENOTFOUND:   Form1.Caption := 'Sample wt@C܂';
          ARTCAMSDK_FPGASET:        Form1.Caption := 'Sample FPGA̐ݒŃG[';
        end;
      end;
    end;
  end;

  result := CallNextHookEx(Hook, code, wparam, lparam);
end;


//////////////////////////////////////////////////
// J
//////////////////////////////////////////////////
procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
  str: String;
begin
  Timer1.Enabled := false;

  // NX\z
  ArtCam1 := TArtCam.Create;

  for i := 0 to 24 do begin
    if ArtCam1.LoadLibrary(DllNameList[i]) then begin
      str := PopupDll[i].Caption;
      str := str + '	Version ';
      str := str + IntToStr(LOWORD(ArtCam1.GetDllVersion()));
      PopupDll[i].Caption := str;
    end
    else begin
      // DLL
      PopupDll[i].Enabled := false;
    end;
  end;

  // tbNłckk̃bZ[W󂯎
  Hook := SetWindowsHookEx(WH_GETMESSAGE, MsgProc, 0, GetCurrentThreadID);
end;


//////////////////////////////////////////////////
// JJ
//////////////////////////////////////////////////
procedure TForm1.FormDestroy(Sender: TObject);
begin
  ArtCam1.Release();

  UnHookWindowsHookEx(Hook);
end;


//////////////////////////////////////////////////
// 摜ۑ
//////////////////////////////////////////////////
procedure TForm1.SaveClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SaveImage('image.png', FILETYPE_PNG);
end;


//////////////////////////////////////////////////
// I
//////////////////////////////////////////////////
procedure TForm1.ExitClick(Sender: TObject);
begin
  CLose;
end;


//////////////////////////////////////////////////
// vr[
//////////////////////////////////////////////////
procedure TForm1.PreviewClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  // ňUfoCXJ
  ArtCam1.Close;

  // \EBhEݒ肷
  // Handle NULLݒ肷ƐVEBhE쐬ĕ\܂
  ArtCam1.SetPreviewWindow(Form1.Handle, 0, 0, Form1.Width, Form1.Height);

  // f\
  // \͂rcjŐ䂵܂̂ŉfɊւ͊{IɎ擾ł܂B
  ArtCam1.Preview;

  // j[`FbN
  ShowPreview.Checked := true;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := false;

  PreviewMode := 0;
  Invalidate;
end;


//////////////////////////////////////////////////
// R[obN
//////////////////////////////////////////////////
procedure TForm1.CallBackClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  // ňUfoCXJ
  ArtCam1.Close;

  // ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
  // CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
  ArtCam1.SetPreviewWindow(Form1.Handle, 0, 0, 0, 0);

  // 荞ݗp̈쐬
  CreateBitmap;

  // f荞
  ArtCam1.CallBackPreview(Form1.Handle, BmpCapture.ScanLine[BmpDraw.Height-1], ArtCamGetSize, FALSE);

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := true;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := false;

  PreviewMode := 1;

  Invalidate;
end;


//////////////////////////////////////////////////
// XibvVbg
//////////////////////////////////////////////////
procedure TForm1.SnapShotClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  // ňUfoCXJ
  ArtCam1.Close;

  // 荞ݗp̈쐬
  CreateBitmap;

  // f荞
  ArtCam1.SnapShot(BmpCapture.ScanLine[BmpDraw.Height-1], ArtCamGetSize, FALSE);

  // 摜`
  DrawImage;

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := false;

  PreviewMode := -1;
end;


//////////////////////////////////////////////////
// Lv`
//////////////////////////////////////////////////
procedure TForm1.CaptureClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  // ňUfoCXJ
  ArtCam1.Close;

  // 荞ݗp̈쐬
  CreateBitmap;

  // f\
  ArtCam1.Capture;

  Timer1.Interval := 200;
  Timer1.Enabled := true;

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := true;
  ShowTrigger.Checked := false;

  PreviewMode := 3;

  Invalidate;
end;


//////////////////////////////////////////////////
// gK[
//////////////////////////////////////////////////
procedure TForm1.TriggerClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  Timer1.Enabled := false;

  // ňUfoCXJ
  ArtCam1.Close;

  // ŕ`悷ꍇ̓EBhETCYSĂOɂ܂
  // CallBackPreview gpꍇłEBhETCYݒ肷Ύ\͍s܂B
  ArtCam1.SetPreviewWindow(Form1.Handle, 0, 0, 0, 0);

  // 荞ݗp̈쐬
  CreateBitmap;

  // f荞
  ArtCam1.Trigger(Form1.Handle, BmpCapture.ScanLine[BmpDraw.Height-1], ArtCamGetSize, FALSE);

  // j[`FbN
  ShowPreview.Checked := false;
  ShowCallBack.Checked := false;
  ShowCapture.Checked := false;
  ShowTrigger.Checked := true;

  PreviewMode := 4;

  Invalidate;
end;


//////////////////////////////////////////////////
// Jݒ
//////////////////////////////////////////////////
procedure TForm1.SetCameraClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SetCameraDlg(Form1.Handle);

  Invalidate;

  case PreviewMode of
  0: PreviewClick(Sender);
  1: CallBackClick(Sender);
  3: CaptureClick(Sender);
  4: TriggerClick(Sender);
  end;
end;


//////////////////////////////////////////////////
// tB^[ݒ
//////////////////////////////////////////////////
procedure TForm1.SetFilterClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SetImageDlg(Form1.Handle);
end;


//////////////////////////////////////////////////
// AiOݒ
//////////////////////////////////////////////////
procedure TForm1.SetAnalogClick(Sender: TObject);
begin
  if not ArtCam1.IsInit then begin ShowMessage('ڑĂJDLLIĂ'); exit; end;
  ArtCam1.SetAnalogDlg(Form1.Handle);
end;


//////////////////////////////////////////////////
// foCXύX
//////////////////////////////////////////////////
procedure TForm1.DeviceChange(Sender: TObject; Number: Integer);
var
  i: Integer;
  DeviceName: array[0..255] of AnsiChar;

begin
  // foCXύXOɎgp̃foCXJ
  ArtCam1.Close;


  // foCXڑĂ邩`FbNꍇ
  // GetDeviceName gΊȒPɕ
  // AO擾̈悪ꍇG[ɂȂ̂Ŕz񒷂͍Œ32͗pӂ鎖
  if not ArtCam1.GetDeviceName(Number, DeviceName, 256) then begin
    PreviewMode := -1;
    exit;
  end;


  // ŃfoCX̔ԍύXĂJ\ƃfoCXύX
  // F̊֐P̂ł̓foCX͕ύX܂B
  // @@̊֐ĂяoɃfoCX鎖ŃfoCXύX܂
  ArtCam1.SetDeviceNumber(Number);

  for i := 0 to 7 do begin
    PopupDevice[i].Checked := false;
  end;
  PopupDevice[Number].Checked := true;


  case PreviewMode of
  0: PreviewClick(Sender);
  1: CallBackClick(Sender);
  3: CaptureClick(Sender);
  4: TriggerClick(Sender);
  end;
end;


//////////////////////////////////////////////////
// foCXI
//////////////////////////////////////////////////
procedure TForm1.Device0Click(Sender: TObject); begin DeviceChange(Sender, 0); end;
procedure TForm1.Device1Click(Sender: TObject); begin DeviceChange(Sender, 1); end;
procedure TForm1.Device2Click(Sender: TObject); begin DeviceChange(Sender, 2); end;
procedure TForm1.Device3Click(Sender: TObject); begin DeviceChange(Sender, 3); end;
procedure TForm1.Device4Click(Sender: TObject); begin DeviceChange(Sender, 4); end;
procedure TForm1.Device5Click(Sender: TObject); begin DeviceChange(Sender, 5); end;
procedure TForm1.Device6Click(Sender: TObject); begin DeviceChange(Sender, 6); end;
procedure TForm1.Device7Click(Sender: TObject); begin DeviceChange(Sender, 7); end;


//////////////////////////////////////////////////
// DLLύX
//////////////////////////////////////////////////
procedure TForm1.DllChange(Sender: TObject; Number: Integer; CameraType: Integer);

var
  DevName: DeviceNameList;
  DevCount: Integer;
  i: Integer;
  Error: string;
begin
  // ckk؂ւۂ͈USĊJ܂B
  // ̃J̓\sۂ TArtCam 𕡐`Kv܂B
  // `Ăꍇ̓J؂ւ̍ۂɊJKv͂ȂȂ܂B
  if ArtCam1.IsInit then begin
    ArtCam1.Release;
    Timer1.Enabled := false;
  end;


  // DLLǂݍ
  if not ArtCam1.LoadLibrary(DllNameList[LONG(Number)]) then begin
    Error := DllNameList[LONG(Number)];
    Error := Error + '܂\nNDLLړ\܂';
    ShowMessage(Error);
    exit;
  end;

  // Initialize ͍ŏɌĂт܂
  // ŃEBhEnhݒ肷WM_ERROR擾鎖o
  if not ArtCam1.Initialize(Handle) then begin
    ShowMessage('rcj̏Ɏs܂');
    exit;
  end;


  // SATAJ͍XɃJ̃^Cvw肷
  if (-1 <> CameraType) and (ARTCAM_CAMERATYPE_SATA = ARTCAM_CAMERATYPE(HIWORD(ArtCam1.GetDllVersion()))) then begin
    ArtCam1.SetCameraType(CameraType);
  end;



  // IDLL`FbN
  for i := 0 to 24 do begin
    PopupDll[i].Checked := false;
  end;
  PopupDll[Number].Checked := true;


  DevCount := ArtCam1.EnumDevice(DevName);
  for i := 0 to DevCount-1 do begin
    ArtCam1.GetDeviceName(i, DevName[i], 256);
    PopupDevice[i].Caption := DevName[i];
    PopupDevice[i].Enabled := true;
  end;

  for i := DevCount to 7 do begin
    PopupDevice[i].Caption := IntToStr(i);
    PopupDevice[i].Enabled := false;
  end;

  // foCXݒ
  DeviceChange(Sender, 0);
end;


//////////////////////////////////////////////////
// DLLI
//////////////////////////////////////////////////
procedure TForm1.DSCameraClick    (Sender: TObject); begin DllChange(Sender,  0, -1); end;
procedure TForm1.ARTUSTClick      (Sender: TObject); begin DllChange(Sender,  2, -1); end;
procedure TForm1.ARTCNVClick      (Sender: TObject); begin DllChange(Sender,  3, -1); end;
procedure TForm1.ARTCAM130MIClick (Sender: TObject); begin DllChange(Sender,  5, -1); end;
procedure TForm1.ARTCAM200MIClick (Sender: TObject); begin DllChange(Sender,  6, -1); end;
procedure TForm1.ARTCAM300MIClick (Sender: TObject); begin DllChange(Sender,  7, -1); end;
procedure TForm1.ARTCAM150PClick  (Sender: TObject); begin DllChange(Sender,  8, -1); end;
procedure TForm1.ARTCAM320PClick  (Sender: TObject); begin DllChange(Sender,  9, -1); end;
procedure TForm1.ARTCAM200SHClick (Sender: TObject); begin DllChange(Sender, 10, -1); end;
procedure TForm1.ARTCAM098Click   (Sender: TObject); begin DllChange(Sender, 11, -1); end;
procedure TForm1.ARTCAM036MIClick (Sender: TObject); begin DllChange(Sender, 12, -1); end;
procedure TForm1.ARTCAM500PClick  (Sender: TObject); begin DllChange(Sender, 13, -1); end;
procedure TForm1.ARTCAM150P2Click (Sender: TObject); begin DllChange(Sender, 14, -1); end;
procedure TForm1.ARTCAM500MIClick (Sender: TObject); begin DllChange(Sender, 15, -1); end;
procedure TForm1.ARTCAMT111Click  (Sender: TObject); begin DllChange(Sender, 16, -1); end;
procedure TForm1.ARTCAMT112Click  (Sender: TObject); begin DllChange(Sender, 17, -1); end;
procedure TForm1.ARTCAM150P3Click (Sender: TObject); begin DllChange(Sender, 18, -1); end;
procedure TForm1.ARTCAM130MIVClick(Sender: TObject); begin DllChange(Sender, 19, -1); end;
procedure TForm1.ARTCAM150P3VClick(Sender: TObject); begin DllChange(Sender, 20, -1); end;
procedure TForm1.ARTCAM267KYClick (Sender: TObject); begin DllChange(Sender, 21, -1); end;
procedure TForm1.ARTCAM274KYClick (Sender: TObject); begin DllChange(Sender, 22, -1); end;

procedure TForm1.ARTCAMSLVDSClick (Sender: TObject); begin DllChange(Sender, 24, 0); end;
procedure TForm1.ARTCAMS300MIClick(Sender: TObject); begin DllChange(Sender, 24, 1); end;
procedure TForm1.ARTCAMS500MIClick(Sender: TObject); begin DllChange(Sender, 24, 2); end;
procedure TForm1.ARTCAMSMV413Click(Sender: TObject); begin DllChange(Sender, 24, 3); end;
procedure TForm1.ARTCAMS800MIClick(Sender: TObject); begin DllChange(Sender, 24, 4); end;
procedure TForm1.ARTCAMS036MIClick(Sender: TObject); begin DllChange(Sender, 24, 5); end;
procedure TForm1.ARTCAMS150PClick (Sender: TObject); begin DllChange(Sender, 24, 6); end;


//////////////////////////////////////////////////
// Lv`p
//////////////////////////////////////////////////
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if Timer1 = Sender then begin
    ArtCam1.SnapShot(BmpDraw.ScanLine[ArtCam1.Height-1], ArtCamGetSize, FALSE);
    DrawImage;
  end;
end;


//////////////////////////////////////////////////
// EBhETCYύX
//////////////////////////////////////////////////
procedure TForm1.FormResize(Sender: TObject);
var
  Child: HWND;
  rc: TRect;
{
  winW: Double;
  winH: Double;
  capW: Double;
  capH: Double;
}
begin
  // vr[[h̍ۂ͂rcjō쐬ꂽqEBhẼTCYςƕ\TCYς܂
  if PreviewMode = 0 then begin
    Child := GetWindow(Form1.Handle, GW_CHILD);
    rc := GetClientRect();

    // AXyNgςȂꍇ͂̃̕RgOĂ
{
    // vZ͏PʂɂȂ̂ňUɂ܂
    winW := rc.Right;
    winH := rc.Bottom;
    capW := ArtCamGetWidth;
    capH := ArtCamGetHeight;

    if (winW * capH) > (winH * capW) then begin
      winW := winH * capW / capH;
      rc.Right := Trunc(winW);
    end
    else
    if (winW * capH) < (winH * capW) then begin
      winH := winW * capH / capW;
      rc.Bottom := Trunc(winH);
    end;
 }

    SetWindowPos(Child, HWND_TOP, 0, 0, rc.Right, rc.Bottom, SWP_NOMOVE or SWP_NOZORDER or SWP_SHOWWINDOW);
  end;
end;


//////////////////////////////////////////////////
// J̃TCY擾
//////////////////////////////////////////////////
function TForm1.ArtCamGetWidth: Integer;
begin
  result := ArtCam1.Width div SUB_SAMPLE[LONG(ArtCam1.GetSubSample)];
end;

function TForm1.ArtCamGetHeight: Integer;
begin
  result := ArtCam1.Height div SUB_SAMPLE[LONG(ArtCam1.GetSubSample)];
end;

function TForm1.ArtCamGetColor: Integer;
begin
  result := ((ArtCam1.GetColorMode + 7) div 8) * 8;
end;

function TForm1.ArtCamGetBpp: Integer;
begin
  result := ((ArtCam1.GetColorMode + 7) div 8);
end;

function TForm1.ArtCamGetSize: Integer;
begin
  result := ArtCamGetWidth * ArtCamGetHeight * ArtCamGetBpp;
end;


//////////////////////////////////////////////////
// rbg}bv쐬
//////////////////////////////////////////////////
procedure TForm1.CreateBitmap;
var
  pal: TMaxLogPalette;
  i: Integer;
begin
  // \p̈
  BmpDraw := TBitmap.Create;
  BmpDraw.Width := ArtCamGetWidth;
  BmpDraw.Height := ArtCamGetHeight;
  BmpDraw.PixelFormat := pf24bit;

  // Ԃyw
  BmpDraw.Canvas.Pen.Color := clRed;

  // 荞ݗp̈
  BmpCapture := TBitmap.Create;
  BmpCapture.Width := ArtCamGetWidth;
  BmpCapture.Height := ArtCamGetHeight;

  case ArtCamGetBpp of
    1: begin
      BmpCapture.PixelFormat := pf8bit;

      // WrbgmN̏ꍇ̓pbg쐬
      for i := 0 to 255 do begin
        pal.palPalEntry[i].peRed   := i;
        pal.palPalEntry[i].peGreen := i;
        pal.palPalEntry[i].peBlue  := i;
        pal.palPalEntry[i].peFlags := 0;
      end;

      pal.palNumEntries := 256;
      pal.palVersion := $0300;
      BmpCapture.Palette := CreatePalette(PLogPalette(@pal)^);
    end;

    2: begin BmpCapture.PixelFormat := pf16bit; end;
    3: begin BmpCapture.PixelFormat := pf24bit; end;
    4: begin BmpCapture.PixelFormat := pf32bit; end;

    6: begin
      // pf48bit ͎woȂ̂ŉTCY{ɂăf[^ʂ𑽂Ă
      // 荞ݗp̈̔z񒷂̓TCY킹ĂΖȂ
      BmpCapture.Width := ArtCamGetWidth * 2;
      BmpCapture.Height := ArtCamGetHeight;
      BmpCapture.PixelFormat := pf24bit;
    end;

    8: begin
      // pf64bit ͎woȂ̂ŉTCY{ɂăf[^ʂ𑽂Ă
      // 荞ݗp̈̔z񒷂̓TCY킹ĂΖȂ
      BmpCapture.Width := ArtCamGetWidth * 2;
      BmpCapture.Height := ArtCamGetHeight;
      BmpCapture.PixelFormat := pf32bit;
    end;
  end;

end;


//////////////////////////////////////////////////
// \
//////////////////////////////////////////////////
procedure TForm1.DrawImage;
var
  pt: TPoint;
  x: Integer;
  y: Integer;
  dx: Integer;
  sx: Integer;
  pDest: PByteArray;
  pSrc : PByteArray;
  SrcBpp: Integer;
begin
  if BmpDraw=nil then begin exit; end;
  if BmpDraw.Empty then begin exit; end;

  SrcBpp := ArtCamGetBpp;


  // 荞ݗp\pɕ`
  case SrcBpp of
    // rbgZȂꍇ͕`悳
    1, 3, 4: begin
      BmpDraw.Canvas.Draw(0, 0, BmpCapture);
    end;

    // 16rbg̍ۂ̓sNZPʂ̃VtgZKv
    2: begin
      for y := 0 to BmpDraw.Height-1 do begin
        pDest := BmpDraw.ScanLine[y];
        pSrc  := BmpCapture.ScanLine[y];
        dx := 0;
        sx := 0;

        for x := 0 to BmpDraw.Width-1 do begin
          pDest[dx  ] := (pSrc[sx+1] shl 6) or (pSrc[sx] shr 2);
          pDest[dx+1] := (pSrc[sx+1] shl 6) or (pSrc[sx] shr 2);
          pDest[dx+2] := (pSrc[sx+1] shl 6) or (pSrc[sx] shr 2);

          dx := dx + 3;
          sx := sx + SrcBpp;
        end;
      end;
    end;

    6, 8: begin
      for y := 0 to BmpDraw.Height-1 do begin
        pDest := BmpDraw.ScanLine[y];
        pSrc  := BmpCapture.ScanLine[y];
        dx := 0;
        sx := 0;

        for x := 0 to BmpDraw.Width-1 do begin
          pDest[dx  ] := (pSrc[sx+1] shl 6) or (pSrc[sx  ] shr 2);
          pDest[dx+1] := (pSrc[sx+3] shl 6) or (pSrc[sx+2] shr 2);
          pDest[dx+2] := (pSrc[sx+5] shl 6) or (pSrc[sx+4] shr 2);

          dx := dx + 3;
          sx := sx + SrcBpp;
        end;
      end;
    end;
  end;


  // C`
  GetCursorPos(pt);
  pt := ScreenToClient(pt);

  // h~ׁ̈AKrbg}bv̕ɃC
  BmpDraw.Canvas.MoveTo(0, pt.y);
  BmpDraw.Canvas.LineTo(BmpDraw.Width, pt.y);
  BmpDraw.Canvas.MoveTo(pt.x, 0);
  BmpDraw.Canvas.LineTo(pt.x, BmpDraw.Height);

  // 摜`
  Canvas.Draw(0, 0, BmpDraw);
end;


end.

